import * as server_main from '@minecraft/server'
import * as uicontroller from './ui_controller.js';
import * as entity_functions from './entity_functions.js';

//INITIALIZES THE COMMAND POST
export async function init_commandpost(player, block, faction){
    let entity_position = (block.x.toString() + " " + (block.y + 1).toString() + " " + block.z.toString())
    player.runCommandAsync('summon lotr:throwable_pretamed_entity_static ' + entity_position + ' ' + faction + '_command')

    player.runCommandAsync('tag @e[type=lotr:command_post, c=1] add command_post')
    player.runCommandAsync('scoreboard players set @e[type=lotr:command_post, c=1] player_host ' + (player.id.toString().slice(5)))
    player.runCommandAsync('scoreboard players set @e[type=lotr:command_post, c=1] chosen_faction ' + entity_functions.get_entity_objective_score(player, 'chosen_faction').toString())

    player.runCommandAsync('tag @s add update_post')
}
//SETS THE COMMAND POS TO THE PLAYER AFER PLACING
export function update_commandpost(player){
    let command_entity = entity_functions.get_nearest_entityTAG_OBJECTIVE(player, 25, "command_post", "player_host", parseInt(player.id.toString().slice(5)))
    player.runCommandAsync('scoreboard players set @s command_post_id ' + command_entity.id.toString().slice(5))
    player.runCommandAsync('tag @s remove update_post')
}
//SETS THE COMMAND POS TO THE PLAYER AFER PLACING
export function destroy_commandpost(player){
    player.runCommandAsync('scoreboard players set @s command_post_id 0')
}



export async function open_commandpost(player, command_entity){
    player.runCommandAsync("tag @s remove command_ui")
    uicontroller.UI_COMMANDPOST(player, command_entity)
}

export function get_command_limit(entity){
    let size = entity_functions.get_entity_objective_score(entity, 'command_level')
    return Math.round(((size * 2) + ((size) % 2)) * 2.2)
}

export function get_command_pop(entity){
    let current_pop = entity_functions.get_entity_objective_score(entity, 'command_population')
    return current_pop
}


