import * as server_main from '@minecraft/server'
import * as entity_functions from './entity_functions.js';
import * as data_convert from './data_convert.js';


export async function modify_commanderXP(commander, amount){
    var commander_curXP = entity_functions.get_entity_objective_score(commander, "command_points")
    var commander_levelXP = entity_functions.get_entity_objective_score(commander, "command_level")

    if (commander_curXP != -1 && commander_levelXP != -1){
        //LVL ALGORITHM
        var xp_nextLVL = Number(getNextLVLXP(commander_levelXP))
        var xpTOTAL = Number(commander_curXP) + Number(amount)

        var isOverlvl12 = (Number(commander_levelXP) >= Number(12)) ? true : false//check if over 12 when first calling
        var lvlsToAdd = 0
        //IF LEVEL UP       
        while (xpTOTAL >= xp_nextLVL){ 
            lvlsToAdd += Number(1)
            xpTOTAL -= Number(xp_nextLVL)
            xp_nextLVL = Number(getNextLVLXP((Number(commander_levelXP) + Number(lvlsToAdd))))
            //server_main.world.say(xpTOTAL.toString() + "/" + xp_nextLVL.toString())
        }
        commander.runCommandAsync('scoreboard players set @s command_points ' + xpTOTAL.toString())//COMMANDER XP
        commander.runCommandAsync('scoreboard players add @s command_level ' + lvlsToAdd.toString())//COMMANDER LEVEL
        commander.runCommandAsync('tag @s add command_settitlebar')//UPDATE UI

        if (Number(lvlsToAdd) > 0){
            commander.runCommandAsync('playsound random.levelup @s ^ ^ ^ 1')//COMMANDER LEVEL
            commander.runCommandAsync('tell @s You Have Leveled Up!')//COMMANDER LEVEL
        }

        //If commander just reached or exceeded level 12, give their commanders sphere
        var new_level = Number(commander_levelXP) + Number(lvlsToAdd)//entity_functions.get_entity_objective_score(commander, "command_level")
        var add_sphere = (Number(new_level) >= Number(12) && isOverlvl12 == false) ? true : false
        //server_main.world.say(Number(new_level).toString() + '  ' + isOverlvl12.toString() + '  ' + add_sphere.toString())
        if (add_sphere){
            var itemname = 'lotr:command_' + data_convert.faction_name(entity_functions.get_entity_objective_score(commander, "chosen_faction")).toString()
            //server_main.world.say(itemname.toString())
            reward_player_item(commander, itemname.toString(), 1)
        }
    }
}

export function reward_player_item(player, itemname, amount){
    player.runCommandAsync('give @p ' + itemname.toString() + ' ' + amount.toString())
}

export function getNextLVLXP(commander_level){
    var xp_nextLVL = (100 * commander_level) * 0.357 + ((commander_level * 0.21) * 0.64) + 7;
    return Math.round(xp_nextLVL);
}
export function getLVLName(commander_level, faction){
    if (data_convert.FactionSIDE(faction) == 'DARK'){
            if(commander_level < 3)
                return 'Maggot';
            else if(commander_level < 6)
                return 'Snaga';
            else if(commander_level < 9)
                return 'Rabble';
            else if(commander_level < 12)
                return 'Warrior';
            else if(commander_level < 18)
                return 'Captain';
            else if(commander_level < 30)
                return 'Warchief';
            else
                return 'Overlord';
    }
    else if (data_convert.FactionSIDE(faction) == 'LIGHT'){
            if(commander_level < 3)
                return 'Peasant'
            else if(commander_level < 6)
                return 'Recruit'
            else if(commander_level < 9)
                return 'Militia'
            else if(commander_level < 12)
                return 'Soldier'
            else if(commander_level < 18)
                return 'Captain'
            else if(commander_level < 30)
                return 'General'
            else
                return 'Lord'
    }
    else{
        return 'Commander'
    }
}
