import * as server_main from '@minecraft/server'

export function get_nearest_entityTYPE(main_ent, dist_max, e_type){
    const query = {
        closest: 1,
        maxDistance: dist_max,
        location: main_ent.location,
        type: e_type
    };
    for (const _entity of server_main.world.getDimension("overworld").getEntities(query)) {
        return _entity
    }
   
}
export function get_nearest_entityTYPE_LOC(start_pos, dist_max, e_type){
    const query = {
        closest: 1,
        maxDistance: dist_max,
        location: start_pos,
        type: e_type
    };
    for (const _entity of server_main.world.getDimension("overworld").getEntities(query)) {
        return _entity
    }
   
}
export function get_nearest_entityTAG(main_ent, dist_max, e_tag){
    let loc = main_ent.location
    const query = {
        closest: 1,
        maxDistance: dist_max,
        location: loc,
        tags: [e_tag]
    };
    for (const _entity of server_main.world.getDimension("overworld").getEntities(query)) {
        return _entity
    }
   
}
export function get_nearest_entityTYPE_OBJECTIVE(start_entity, dist_max, e_type, objective_name, objective_value){
    const query = {
        location: start_entity.location,
        maxDistance: dist_max,
        type: e_type,
        scoreOptions: [{
            objective: objective_name,
            maxScore: parseInt(objective_value),
            minScore: parseInt(objective_value)
        }]
    };
    const entities = server_main.world.getDimension("overworld").getEntities(query);
    for (const entity of entities) {
        return entity    
    }
   
}

export function get_nearest_entityTYPE_OBJECTIVE_LOC(start__loc, dist_max, e_type, objective_name, objective_value){
    let query = {
        location : start__loc,
        maxDistance : dist_max,
        type : e_type,
        scoreOptions: [{
            objective: objective_name,
            maxScore: parseInt(objective_value),
            minScore: parseInt(objective_value)
        }]
    };
    const entities = server_main.world.getDimension("overworld").getEntities(query);
    for (const entity of entities) {
        return entity    
    }
   
}
export function get_nearest_entityTAG_OBJECTIVE(player, dist_max, e_tag, objective_name, objective_value){
    let query = {
        location: player.location,
        maxDistance: dist_max,
        tags: [e_tag],
        scoreOptions: [{
            objective: objective_name,
            maxScore: parseInt(objective_value),
            minScore: parseInt(objective_value)
        }]
    };
    const entities = server_main.world.getDimension("overworld").getEntities(query);
    for (const entity of entities) {
        return entity    
    }
    return -1 
}

//ID IS PRE-Sliced
export function get_playerBy_ID_dist(main_ent, dist_max, pID){
    let location = main_ent.location
    //let loc = new server_main.Vector = ({x:location.x, y:location.y, z:location.z});
    const loc = server_main.Vector = {x:location.x, y:location.y, z:location.z};
    const query = {
        maxDistance: dist_max,
        location: loc,
        type: "minecraft:player"
    }
    for (const _entity of server_main.world.getDimension("overworld").getEntities(query)) {
        if ((_entity.id.toString().slice(5)) == pID)
        return _entity
    }
   
}

//ID IS PRE-Sliced
export function get_playerBy_ID(pID){
    for (const player of server_main.world.getAllPlayers()) {
        if ((player.id.toString().slice(5)) == pID)
            return player
    }
   
}
export function get_entity_objective_score(entity, objectiveID){
    let scoreboardObjective = server_main.world.scoreboard.getObjective(objectiveID)   ;

    try {
        let score = scoreboardObjective.getScore(entity.scoreboardIdentity);
        return score.toString()     ;  
    } 
    catch (e) {
        //server_main.world.sendMessage("Error: " + e);
        return -1;
    }    
}

export function remove1fromplayerhand(p){
    p.runCommandAsync("replaceitem entity @p slot.weapon.mainhand 0 air 0 0")
}

export function check_factions(p, e){
    if (get_entity_objective_score(p, "chosen_faction") == get_entity_objective_score(e, "chosen_faction")){
        return true;
    }
    return false;
}

export function check_valid_score(entity, objective){
    if (get_entity_objective_score(entity, objective) == -1 || get_entity_objective_score(entity, objective) == 0){
        return false;
    }
    return true;
}
export function get_entitycommandvalue(entity){
    let tags = entity.getTags()





    for (const _entity of server_main.world.getDimension("overworld").getEntities(query)) {
        if ((_entity.id.toString().slice(5)) == pID)
        return _entity.getTags()
    }
}

export function isEntityRecruited(entity){
    var tags
    try {
        tags = entity.getTags()   
    } 
    catch (e) {
        return false
    }    
    for (const tag of tags) {
        if (tag.toString().slice(0,11)=="lotr:tamed_"){
            return true
        }
    }
    return false
}