import * as server_main from '@minecraft/server'
import * as command_controller from './command_controller.js';
import * as entity_functions from './entity_functions.js';


export function recruit_check(player, entity, recruitCost){
     //Check if the player is the same faction
     if (!entity_functions.check_factions(player, entity)){
        player.sendMessage("Cant recruit this faction...")
        return false
    }
    //Check if the player has a command post
    if (!entity_functions.check_valid_score(player, "command_post_id")){
        player.sendMessage("Player does not have a valid command post...")
        return false
    }
    //Make sure player has the population
    if (!((Number(command_controller.get_command_pop(player)) + Number(recruitCost)) < command_controller.get_command_limit(player))){
        player.sendMessage("Not enough population to recruit...")
        return false
    }
    return true
}

export function fail_spawn(entity){
    let tags = entity.getTags()
    entity.runCommandAsync(('give @p ' + tags[0] +  ' 1'))

    entity.runCommandAsync("clear")
    entity.triggerEvent("death")
    entity.kill()
  
}

export function fail_spawn_c(entity, commander){
    let tags = entity.getTags()
    commander.runCommandAsync(('give @s ' + tags[0] +  ' 1'))

    entity.runCommandAsync("clear")
    entity.triggerEvent("death")
    entity.kill()
  
}




